<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallFooter extends CPlugin{
	
	var $tplvars; 

	function COXYMallFooter() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		if (strstr($_GET["sub"] , "oxymall.plugin.footer.")) {
			$sub = str_replace("oxymall.plugin.footer." , "" ,$_GET["sub"]);
			$action = $_GET["action"];

			//read the module
			

			switch ($sub) {

				case "landing":

					if (($_GET["action"] == "moveup") || ($_GET["action"] == "movedown")) {
						$this->__call_reorder_cats($_GET["action"]);
					}
					
					$data = new CSQLAdmin("footer/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);

					$this->PrepareFields(&$data->forms["forms"], $sub);

					$data->functions = array( 
							"onstore" => array(&$this , "StoreCat"),
					);					

					return $data->DoEvents();

				break;

				case "images":

					if (($_GET["action"] == "moveup") || ($_GET["action"] == "movedown")) {
						$this->__call_reorder_images($_GET["action"]);
					}
					
					$data = new CSQLAdmin("footer/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);

					$this->PrepareFields(&$data->forms["forms"] , $sub);

					$data->functions = array( 
							"onstore" => array(&$this , "StoreImage"),
					);					

					return $data->DoEvents();

				break;

				case "social":

					if (($_GET["action"] == "moveup") || ($_GET["action"] == "movedown")) {
						$this->__call_reorder_social($_GET["action"]);
					}
					
					$data = new CSQLAdmin("footer/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);

					$this->PrepareFields(&$data->forms["forms"] , $sub);

					$data->functions = array( 
							"onstore" => array(&$this , "StoreSocial"),
					);					

					return $data->DoEvents();

				break;


			}
		}
	}


	/**
	* description
	*
	* @param
	*
	* @return
	*
	* @access
	*/
	function PrepareFields($forms , $sub) {

		if (is_array($forms["search"])) {
			$forms["search"]["title"] = CTemplateStatic::Replace(
				$forms["search"]["title"],
				array( "title" => $this->tpl_module["mod_name"])
			);
		}

		$forms["list"]["title"] = CTemplateStatic::Replace(
			$forms["list"]["title"],
			array( "title" => $this->tpl_module["mod_name"])
		);

		$forms["edit"]["title"] = CTemplateStatic::Replace(
			$forms["edit"]["title"],
			array( "title" => $this->tpl_module["mod_name"])
		);

		$forms["add"]["title"] = CTemplateStatic::Replace(
			$forms["add"]["title"],
			array( "title" => $this->tpl_module["mod_name"])
		);

	}
	

	/**
	* description
	*
	* @param
	*
	* @return
	*
	* @access
	*/
	function StoreCat($record) {
		if ($record["cat_id"] && !$record["cat_order"]) {
			$this->db->QueryUpdate(
				$this->tables["plugin:footer_cats"],
				array(
					"cat_order" => $record["cat_id"]
				),
				"cat_id='{$record[cat_id]}'"
			);
		}		
	}
	

	function __call_reorder_cats($action) {

		$sql = "SELECT * FROM {$this->tables['plugin:footer_cats']} WHERE cat_order " . ($_GET["action"] == "moveup" ? " <= " : " >= " ) . " '{$_GET[cat_order]}' ORDER BY cat_order " . ($_GET["action"] == "moveup" ? " DESC " : " ASC " ) . " LIMIT 2 " ;

		$rows = $this->db->QFetchRowArray($sql);

		if (count($rows) == 2) {

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:footer_cats'],
						array(
							"cat_order" => $rows[1]["cat_order"]
						),
						" cat_id='{$rows[0][cat_id]}'"
					);

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:footer_cats'],
						array(
							"cat_order" => $rows[0]["cat_order"]
						),
						" cat_id='{$rows[1][cat_id]}'"
					);
		}

		//debug($_SERVER);

		UrlRedirect($_SERVER["HTTP_REFERER"]);
		die;
	}

	function StoreImage($record) {
		if ($record["item_id"] && !$record["item_order"]) {
			$this->db->QueryUpdate(
				$this->tables["plugin:footer_items"],
				array(
					"item_order" => $record["item_id"]
				),
				"item_id='{$record[item_id]}'"
			);
		}		
	}

	function __call_reorder_images($action) {

		$item = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:footer_items']} WHERE item_id='{$_GET[item_id]}' ");


		$sql = "SELECT * FROM {$this->tables['plugin:footer_items']} WHERE item_cat='{$item[item_cat]}' AND item_order " . ($_GET["action"] == "moveup" ? " <= " : " >= " ) . " '{$_GET[item_order]}' ORDER BY item_order " . ($_GET["action"] == "moveup" ? " DESC " : " ASC " ) . " LIMIT 2 " ;

		$rows = $this->db->QFetchRowArray($sql);

		if (count($rows) == 2) {

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:footer_items'],
						array(
							"item_order" => $rows[1]["item_order"]
						),
						" item_id='{$rows[0][item_id]}'"
					);

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:footer_items'],
						array(
							"item_order" => $rows[0]["item_order"]
						),
						" item_id='{$rows[1][item_id]}'"
					);
		}

		//debug($_SERVER);

		UrlRedirect($_SERVER["HTTP_REFERER"]);
		die;
	}




	function StoreSocial($record) {
		if ($record["item_id"] && !$record["item_order"]) {
			$this->db->QueryUpdate(
				$this->tables["plugin:footer_social"],
				array(
					"item_order" => $record["item_id"]
				),
				"item_id='{$record[item_id]}'"
			);
		}		
	}

	function __call_reorder_social($action) {


		$sql = "SELECT * FROM {$this->tables['plugin:footer_social']} WHERE item_order " . ($_GET["action"] == "moveup" ? " <= " : " >= " ) . " '{$_GET[item_order]}' ORDER BY item_order " . ($_GET["action"] == "moveup" ? " DESC " : " ASC " ) . " LIMIT 2 " ;

		$rows = $this->db->QFetchRowArray($sql);

		if (count($rows) == 2) {

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:footer_social'],
						array(
							"item_order" => $rows[1]["item_order"]
						),
						" item_id='{$rows[0][item_id]}'"
					);

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:footer_social'],
						array(
							"item_order" => $rows[0]["item_order"]
						),
						" item_id='{$rows[1][item_id]}'"
					);
		}

		//debug($_SERVER);

		UrlRedirect($_SERVER["HTTP_REFERER"]);
		die;
	}


}

?>