<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallAbout extends CPlugin{
	
	var $tplvars; 

	function COXYMallAbout() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		if ($_GET["sub"] == "oxymall.plugin.about.landing") {
			return $this->GeneratePage();
		}
	}

	function GeneratePage() {
		global $base , $_TSM;
		$this->__init();

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();

		if ($_GET["page"]) {
			$page = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:about_pages']} WHERE module_id='{$this->tpl_module[mod_id]}' AND item_url='{$_GET[page]}'");
		}

		//if no page get the first one
		if (!is_array($page)) {
			$page = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:about_pages']} WHERE module_id='{$this->tpl_module[mod_id]}' ORDER BY item_order ASC LIMIT 1");
		}

		//build the pages menu
		$pages = $this->db->QFetchRowArray("SELECT item_title,item_id,item_url FROM {$this->tables['plugin:about_pages']} WHERE module_id='{$this->tpl_module[mod_id]}' ORDER BY item_order ASC");
		if (is_array($pages)) {
			foreach ($pages as $key => $val) {
				$pages[$key]["title"] = $this->private->templates["pages"]->blockReplace(
					$val["item_id"] == $page["item_id"] ? "TitleSelected" : "Title",
					$val
				);
			}			
		}

		//set the seo fields
		$this->module->plugins["modules"]->SetSeo($page);
		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				$page["item_title"]	=> $this->tpl_module["mod_url"]  . "/" . $page["item_url"] . "/"
			)
		);
		
		$this->__init();


		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module			
		);

		return CTemplateStatic::Replace(
			$this->private->templates["pages"]->BlockReplace(
				"PageWithMenu",
				array(
					"item_title"		=> $page["item_title"],
					"item_body"			=> $page["item_body"],

					"side"				=> $page["item_column_title"] ? $this->private->templates["pages"]->BlockReplace(
							"Side",
							array(
								"title"	=> $page["item_column_title"],
								"data"	=> $page["item_column_body"],
							)
					) : "",

					"pages"				=> CTemplateStatic::Replace(
						$base->html->table(
							$this->private->templates["pages"],
							"Pages",
							$pages
						),
						array(
							"title"	=> $this->tpl_module["settings"]["set_title"]
						)
					)
				)
			),
			$this->tpl_module
		);

	}

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/about/";

		$templates = array(
			"pages" => "pages.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}

	function GetAllLinks($module , $links) {
		//get all the pages
		$pages = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:about_pages']} WHERE module_id={$module[mod_id]} ORDER BY item_order ASC");

		if (is_array($pages)) {

			//remove the first
			unset($pages[0]);

			if (!count($pages)) {
				return "";
			}
			
			foreach ($pages as $key => $val) {
				$links[] = array(
					"url" => $module["mod_url"] . "/" . $val["item_url"] . "-" . $val["item_id"] . "/",
					"priority"	=> "0.6",
				);

			}			
		}
		
	}
	

}

?>