<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallContact extends CPlugin{
	
	var $tplvars; 

	function COXYMallContact() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		if ($_GET["sub"] == "oxymall.plugin.contact.landing") {
			return $this->GeneratePage();
		}

		if ($_GET["sub"] == "oxymall.plugin.contact.send") {
			return $this->SendMessage();
		}
	}

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/contact/";

		$templates = array(
			"contact" => "contact.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}

	function GeneratePage() {
		global $base , $_TSM;

		$this->__init();

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();

		//check for regarding frop
		$regarding = explode("\n" , trim($this->tpl_module["settings"]["set_regarding_drop"]));

		if (count($regarding)) {
			foreach ($regarding as $key => $val) {
				$val = explode("|" , $val );
				$contacts[] = array(
					"value" => trim($val[0]),
				);
			}
			
			$regarding = $base->html->table(
				$this->private->templates["contact"],
				"Regarding",
				$contacts
			);
		} else 
			$regarding = "";

		//set the module seo 
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module			
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/"
			)
		);


		$fields = array("title" , "header" , "contact_form" , "location_title" , "location_header" , "location_image" , "location_image_link" , "directions_title" , "directions_header");

		if (is_array($fields)) {
			foreach ($fields as $key => $val) {
				$vars[$val] = $this->vars->data["contact_{$val}_" . $this->tpl_module["mod_id"]];
			}			
		}

		//add the module it its used for image identification and for mailing form
		$vars["mod_id"] = $this->tpl_module["mod_id"];

		//add the regarding if needed
		$vars["regarding"] = $regarding;

		//process for image
		if ($vars["location_image"]) {
			$vars["image"] = $this->private->templates["contact"]->blockReplace(
				$vars["location_image_link"] ? "ImageLink" : "Image", 
				$vars
			);

		} else
			$vars["image"] = "";
		

		return $this->private->templates["contact"]->blockReplace(
			"Main",
			$vars
		);
		
	}
	

	function SendMessage() {
		global $_CONF , $_NO_HTACCESS;

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();		

		$this->__init();

		$vars = array(
			"name" => stripslashes($_POST["name"]),
			"email" => stripslashes($_POST["email"]),
			"subject" => stripslashes($_POST["subject"]),
			"message" => nl2br(stripslashes($_POST["message"])),
		);

		if(!preg_match("/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/",$vars["email"])){
			echo $this->private->templates["contact"]->BlockReplace(
				"ErrorEmail",
				array()
			);
			die("");
		}

		foreach ($vars as $key => $val) {
			if (trim($val)=="") {
				//not all fields so returns error
				echo $this->private->templates["contact"]->BlockReplace(
					"Error" . ucwords($key),
					array()
				);
				die();
			}
		}

		$vars["regarding"] = stripslashes($_POST["department"]);

		//save the email to database
		$id = $this->db->QueryInsert(
			$this->tables["plugin:contact_messages"],
			$contact = array(
				"module_id"		=> $this->tpl_module["mod_id"],
				"item_new"		=> 1,
				"item_date"		=> time(),
				"item_email"	=> $vars["email"],
				"item_name"		=> $vars["name"],
				"item_subject"	=> $vars["subject"],
				"item_message"	=> $vars["message"],
				"item_department"	=> $vars["regarding"],

			)

		);

		if ($vars["regarding"]) {
			//process the department
			$regarding = explode("\n" , trim($this->tpl_module["settings"]["set_regarding_drop"]));

			if (count($regarding)) {
				foreach ($regarding as $key => $val) {
					$val = explode("|" , $val );
					if (trim($val[0]) == $vars["regarding"]) {
						$this->tpl_module["settings"]["set_email_1_to_email"] = trim($val["1"]);
						$this->tpl_module["settings"]["set_email_1_to_name"] = trim($val["2"]);
					}
				}
			} 
		}

		$email = array(
			"email_to" => utf8_decode($this->tpl_module["settings"]["set_email_1_to_email"]),
			"email_to_name" => utf8_decode($this->tpl_module["settings"]["set_email_1_to_name"]),

			"email_from" => utf8_decode($this->tpl_module["settings"]["set_email_1_from_email"]),
			"email_from_name" => utf8_decode($this->tpl_module["settings"]["set_email_1_from_name"]),

			"email_subject" => utf8_decode($this->tpl_module["settings"]["set_email_1_subject"]),
			"email_body" => utf8_decode($this->tpl_module["settings"]["set_email_1_message"]),
			"email_type" => "html"
		);

		foreach ($email as $key => $val) {
			$email[$key] = CTemplateStatic::Replace($val , $vars);
		}


		//send the email
		$this->module->plugins["mail"]->SendMail($email);

		//send the responder
		if ($this->tpl_module["settings"]["set_email_2"]) {

			$email = array(
				"email_to" => utf8_decode($vars["email"]),
				"email_to_name" => utf8_decode($vars["name"]),

				"email_from" => utf8_decode($this->tpl_module["settings"]["set_email_2_to_email"]),
				"email_from_name" => utf8_decode($this->tpl_module["settings"]["set_email_2_to_name"]),

				"email_subject" => utf8_decode($this->tpl_module["settings"]["set_email_2_subject"]),
				"email_body" => utf8_decode($this->tpl_module["settings"]["set_email_2_message"]),
				"email_type" => "html"
			);

			foreach ($email as $key => $val) {
				$email[$key] = CTemplateStatic::Replace($val , $vars);
			}

			//send the email
			$this->module->plugins["mail"]->SendMail($email);
		}

		echo $this->private->templates["contact"]->BlockReplace(
			"ErrorSuccess",
			array()
		);
		die();
		
	}


	function GetAllLinks($module , $links) {
	}
		
}

?>