<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallGallery extends CPlugin{	
	
	var $tplvars; 

	function COXYMallGallery() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		if ($_GET["sub"] == "oxymall.plugin.gallery.landing") {
			return $this->Landing();
		}
	}

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/gallery/";

		$templates = array(
			"main" => "main.htm",
			"landing" => "landing.htm",
			"widgets" => "widgets.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}

	function Landing() {
		global $_TSM;

		$this->__init();
		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();
		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo($this->tpl_module);


		switch ($this->tpl_module["settings"]["set_display"]) {
			default:
				return $this->SimpleLanding();
			break;

			case "1":
				return $this->Albums();
			break;
		}
		
	}

	function Albums() {
		global $base , $_TSM;

		$columns = 5;

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/"
			)
		);

		if ($_GET["gallery"]) {
			$category = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:gallery_cats']} WHERE module_id={$this->tpl_module[mod_id]} AND cat_id='{$_GET[gallery]}'");			
		} else {
			$category = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:gallery_cats']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY cat_order ASC LIMIT 1");
		}
		
		//set the seo for this category
		$this->module->plugins["modules"]->SetSeo($category);

		//get all the categories
		$categories = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:gallery_cats']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY cat_order ASC");

		//get photos from this categry

		$photos = $this->getImages($this->tpl_module["settings"]["set_items"], $_GET["page"] , $category);

		$photos["records"] = $this->ProcessPhotos($photos["records"] , $columns  , $category);

		return $this->private->templates["landing"]->BlockReplace(
			"Albums",
			array(
	
				"content"		=> CTemplateStatic::Replace(
										$base->html->table(
											$this->private->templates["main"],
											"",
											$photos["records"]
										),
										array(
											"columns" => $columns
										)
									),

				"title"			=> $category["cat_title"],

				"categories"	=> CTemplateStatic::Replace(
										$base->html->table(
											$this->private->templates["landing"],
											"Categories",
											$categories
										),
										$this->tpl_module
									),

				
				"paging"		=> $this->module->plugins["paging"]->Paging(
										$photos["pages"] , 
										$photos["page"], 
										array(
											"first" => $this->tpl_module["mod_url"] . "/" . $category["cat_url"] . "-" . $category["cat_id"] . "/",
											"all" => $this->tpl_module["mod_url"] . "/" . $category["cat_url"] . "-" . $category["cat_id"] . "/{PAGE}/",
										)
									),

				"latest_photos"	=> $this->WidgetLatestPhotos(),

			)
		);
	}
	
	

	function SimpleLanding() {
		global $base , $_TSM;


		//get the first gallery if none selecte
		$photos = $this->getImages($this->tpl_module["settings"]["set_items"], $_GET["page"] );

		if (is_array($photos["records"])) {
			$count = 1;

			$photos["records"] = $this->ProcessPhotos($photos["records"] , 8 );

			$gallery_content = $base->html->table(
				$this->private->templates["main"],
				"",
				$photos["records"]
			);
			
		}
					
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);		
		//add the module info

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/"
			)
		);

		return $this->private->templates["landing"]->BlockReplace(
			"Simple",
			array(
				"gallery"	=> $gallery_content,
				"gallery_name"	=> $gallery["cat_title"],


				"paging"=> $this->module->plugins["paging"]->Paging(
					$photos["pages"] , 
					$photos["page"], 
					array(
						"first" => $this->tpl_module["mod_url"] . "/",
						"all" => $this->tpl_module["mod_url"] . "/{PAGE}/",
					)
				),

				"mod_name"	=> $this->tpl_module["mod_long_name"],

			)
		);
	}


	function getImages($count = 10, $page = 1  , $category = null) {
		global $_DOMAIN_ID;

		$page = (int)$page ? $page : 1;

		//debug($conds);

		$fields = "*";

		if (is_array($category)) {
			$cond = "item_cat={$category[cat_id]} AND ";
		}
		
		
		$items = $this->db->QFetchRowArray(
			"SELECT {$fields} " . 
			"FROM {$this->tables['plugin:gallery_items']} " . 
			"WHERE " . 
			$cond .
			"module_id={$this->tpl_module[mod_id]} " . 
			"ORDER BY  item_order ASC " . 
			"LIMIT " . ( ($page - 1 ) * $count ) . " , " . $count 
		);
		

		//get the elements count
		$items_count = $this->db->RowCount(
			$this->tables['plugin:gallery_items'],
			"WHERE " . 
			$cond .
			"module_id={$this->tpl_module[mod_id]} "
		);
		
		return array(
			"records"	=> $items , 
			"count"		=> $items_count , 
			"pages"		=> $items_count ? ceil($items_count / $count) : 1,
			"page"		=> $page,
			"search"	=> $conds["search"]
		);		
	}

	function ProcessPhotos($photos , $cnt) {
		global $_CONF;

		if (!is_array($photos)) {
			return "";
		}

		$count = 1;
		
		foreach ($photos as $key => $val) {
			if ($count == 1) {
				$photos[$key]["class"] = $this->private->templates["main"]->BlockReplace("class-first" , $val);
			} else
				$photos[$key]["class"] = "";

			if ($count != $cnt) {
				$photos[$key]["extra"] = "";
			} else {				
				$photos[$key]["extra"] = $this->private->templates["main"]->BlockReplace("Extra" , $val);
			}

			if ($count < $cnt) {						
				$count ++;
			} else {
				$count = 1;
			}


			//check the type of the image
			switch ($val["item_type"]) {
				case "1":
					$photos[$key]["source"] = $_CONF["url"] . "upload/galleries/{$val[item_id]}.jpg";
				break;

				case "4":
					$photos[$key]["source"] = $val["item_youtube"];
				break;

				case "5":
					$photos[$key]["source"] = $_CONF["url"] . "upload/galleries/{$val[item_id]}.swf";
				break;

			}
			
		}

		return $photos;
	}

	function WidgetLatestPhotos() {
		global $base;

		$images  = $this->GetLatestPhotos($this->tpl_module["settings"]["set_widget_items"]);

		if (count($images)) {
			return CTemplateStatic::Replace(
				$base->html->table(
					$this->private->templates["widgets"],
					"Images" , 
					$images
				) , 
				array(
					"title"	=> $this->tpl_module["settings"]["set_widget_title"] , 
				)
			);
		}		
	}

	function GetLatestPhotos($count) {
		$images = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:gallery_items']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY item_order DESC LIMIT {$count}"
		);

		return $images;
	}
	

	function GetLatestRecords($module , $count = 6) {
		$items = $this->db->QFetchRowArray(
			"SELECT item_id, item_title " . "FROM {$this->tables['plugin:gallery_items']} " . 
			"WHERE " . "module_id={$module[mod_id]} " . 
			"ORDER BY item_order DESC " . 
			"LIMIT $count "
		);

		return $items;
	}

	function GetAllLinks($module , $links) {
	}

}

?>