<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallHomepage extends CPlugin{
	
	var $tplvars; 

	function COXYMallHomepage() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		if ($_GET["sub"] == "oxymall.plugin.homepage.landing") {
			return $this->GeneratePage();
		}
	}	

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/homepage/";

		$templates = array(
			"main" => "main.htm",
			"slider" => "slider.htm",
			"slider_small" => "slider_small.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}


	function GeneratePage() {
		global $base , $_TSM;

		$this->__init();
		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();

		
		//set the slider
		$_TSM["TOP:SLIDER"] = $this->TopSlider();

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module			
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
		);

				
		//set the module seo 
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		//get all the blocks
		$items = $this->db->QFetchRowArray("SELECT* FROM {$this->tables['plugin:homepage_products']} WHERE module_id={$this->tpl_module['mod_id']} ORDER BY item_order ASC LIMIT 19");

		if (is_array($items)) {
			$cnt = 1;
			foreach ($items as $key => $val) {

				$items[$key]["class"] = $cnt;
				$items[$key]["image"] = $val["item_image"] ? $this->private->templates["main"]->blockReplace(
					"Image",
					$val
				): "";

				$items[$key]["item_description"] = nl2br($val["item_description"]);


				$cnt ++;

				if ($cnt == 4) {
					$cnt = 1;
				}
			}

		}
		

		return $this->private->templates["main"]->blockReplace(
			"Main",
			array(

				"boxes" => $base->html->Table(
					$this->private->templates["main"],
					"",
					$items
				),
				"subtitle"	=> $this->tpl_module["settings"]["set_subtitle"],
			)
		);
		
	}

	function TopSlider() {
		global $base;

		$this->__init();


		$items = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:homepage_images']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY item_order ASC"
		);

		if (is_array($items)) {
			foreach ($items as $key => $val) {

				$items[$key]["content"] = $this->private->templates[($this->tpl_module["settings"]["set_type"] == 2? "slider_small" : "slider")]->blockReplace(
					($val["item_link"] ? "Link" : "NoLink"), 
					$val
				);
			}

			for ($i = count($items); $i > 0 ; $i--) {
				$slide[] = array("id" => $i - 1);				
			}
			
		}

		if (is_array($items)) {
			return CTemplateStatic::Replace(
				$base->html->Table(
					$this->private->templates[($this->tpl_module["settings"]["set_type"] == 2? "slider_small" : "slider")],
					"",
					$items
				),
				array(
					"slider_nav"	=>	$base->html->Table(
						$this->private->templates[($this->tpl_module["settings"]["set_type"] == 2? "slider_small" : "slider")],
						"SliderNav",
						$slide
					),
					
				)
			);
		}
		
		

	}

	function QuickAbout() {
	}
	
	function LatestNews() {
		global $base;
		$this->__init();
		
		if (!$this->tpl_module["settings"]["set_latest_news"]) {
			return "";
		}

		
		$items = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:homepage_products']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY item_order ASC");

		if (is_array($items)) {
			foreach ($items as $key => $val) {
				$items[$key]["title"] = $this->private->templates["news"]->BlockReplace(
					$val["item_url"] ?  "TitleLink" : "TitleNoLink" ,
					$val
				);

				$items[$key]["date"] = $this->tpl_module["settings"]["set_latest_news_date"] ? date($this->tpl_module["settings"]["set_latest_news_date"] , $val["item_date"]) : "";
			}
			
		}
		

		return $this->private->templates["news"]->BlockReplace(
			"Main" ,
			array(
				"items" => $base->html->Table(
					$this->private->templates["news"],
					"",
					$items
				),

				"title"	=> $this->tpl_module["settings"]["set_latest_news_title"],
				
				"rss"	=> "",

				"read_more"	=> $this->private->templates["news"]->Blockreplace(
						$this->tpl_module["settings"]["set_latest_news_button"] ? "ReadMore" : "NoReadMore" , 
						$this->tpl_module["settings"]
				),
			)
		);
		
		
	}
	

	function GetAllLinks($module , $links) {
	}

	function Contact() {
		$this->__init();

		if (!$this->tpl_module["settings"]["set_contact"]) {
			return "";
		}

		if (!$this->tpl_module["settings"]["set_contact_module"]) {
			return "";
		}

		if ($this->tpl_module["settings"]["set_contact_module"]) {
			$mod = $this->module->plugins["modules"]->GetModuleByID($this->tpl_module["settings"]["set_contact_module"]);
 
			$flds = array(
				"title" , "desc","address","phone","fax","web","email"
			);

			foreach ($flds as $key => $val) {
				if ($this->vars->data["contact_{$val}_" . $mod["mod_id"]]) {
					 $fields[$val] = $this->private->templates["contact"]->blockREplace(
						 $val , 
						array(
							"value" => $this->vars->data["contact_{$val}_" . $mod["mod_id"]]
						 )
					);
				} else 
					$fields[$val] = "";				
			}
		}

		return $this->private->templates["contact"]->blockReplace(
			"Contact",
			array_merge(
				array(
					"box_title"		=> $this->tpl_module["settings"]["set_contact_title"],
					"header"	=> $this->tpl_module["settings"]["set_contact_header"],
					"mod_url" => $mod["mod_url"]
				),
				$fields
			)
		);
	}
	

}

?>