<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallLinks extends CPlugin{	
	
	var $tplvars; 

	function COXYMallLinks() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		if ($_GET["sub"] == "oxymall.plugin.links.landing") {
			return $this->GeneratePage();
		}
	}
	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/links/";

		$templates = array(
			"links" => "links.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}


	function GeneratePage() {
		global $base , $_TSM;
		$this->__init();

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();
		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo($this->tpl_module);

		//get all categories
		//get the first gallery if none selecte
		if (!$_GET["category"]) {
			$category = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:links_cats']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY cat_order ASC LIMIT 1");
			$_GET["category"] = $category["cat_url"];
		}

		if (!is_array($category) && ($_GET["category"])) {
			$category = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:links_cats']} WHERE module_id={$this->tpl_module[mod_id]} AND cat_url='{$_GET[category]}' ");
		}


		
		//get all categories
		$cats = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:links_cats']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY cat_order ASC"
		);

		if (!is_array($category)) {
			return "";
		}


		if (is_array($cats)) {
			foreach ($cats as $key => $val) {
			}			
		}

		if (is_Array($category)) {
			$images = $this->GetLinks($category, $this->tpl_module["settings"]["set_items"] , $_GET["page"]);
		}

		if (is_array($images["records"])) {
			$cnt = 0;
			foreach ($images["records"] as $key => $val) {
				$images["records"][$key]["image"] = $this->private->templates["links"]->blockReplace(
					$val["item_image"] ? "LinksImage" : "LinksNoImage" ,
					$val
				);

				$images["records"][$key]["class"] = $cnt ? "last" : "";
				$images["records"][$key]["extra"] =	$cnt ? "" : "";

				$images["records"][$key]["item_description"] = nl2br($val["item_description"]);

				$cnt = !$cnt;
			}
			
		}
		
		$this->module->plugins["modules"]->SetSeo($category);
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		return CTemplateStatic::Replace(
			$this->private->templates["links"]->BlockReplace(
				"Main",
				array(
					"categories"	=> 	$base->html->Table(
						$this->private->templates["links"],
						"Cats",
						$cats
					),

					"items"	=> $base->html->Table(
						$this->private->templates["links"],
						"Links",
						$images["records"]
					),

					"pagination"=> $this->module->plugins["paging"]->Paging(
						$images["pages"] , 
						$images["page"], 
						array(
							"first" => $this->tpl_module["mod_url"] . "/" .$category["cat_url"] . "/",
							"all" => $this->tpl_module["mod_url"] . "/" .$category["cat_url"] . "/{PAGE}/",
						)
					),

				)
			),
			array_merge(
				$this->tpl_module,
				(array)$category
			)
		);

	}

	function getLinks($category , $count = 10, $page = 1 ) {
		global $_DOMAIN_ID;

		$page = (int)$page ? $page : 1;

		//debug($conds);

		$fields = "*";
		
		$products = $this->db->QFetchRowArray(
			"SELECT {$fields} " . 
			"FROM {$this->tables['plugin:links_items']} " . 
			"WHERE " . 
			"item_cat={$category[cat_id]} ".
			"ORDER BY  item_order ASC " . 
			"LIMIT " . ( ($page - 1 ) * $count ) . " , " . $count 
		);
		

		//get the elements count
		$products_count = $this->db->RowCount(
			$this->tables['plugin:links_items'],
			"WHERE " . 
			"item_cat={$category[cat_id]} "
		);
		
		return array(
			"records"	=> $products , 
			"count"		=> $products_count , 
			"pages"		=> $products_count ? ceil($products_count / $count) : 1,
			"page"		=> $page,
			"search"	=> $conds["search"]
		);		
	}
	
	function GetAllLinks($module , $links) {
		//get all news for this module

		$cats = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:links_cats']} " .
			"WHERE module_id={$module[mod_id]}"
		);


		if (is_array($cats)) {
			foreach ($cats as $key => $val) {
				$links[] = array(
					"url" => $module["mod_url"] . "/" . $val["cat_url"] . "/",
					"priority" => "0.8",
				);
			}
		}
		

	}

}

?>