<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallPortfolio extends CPlugin{	
	
	var $tplvars; 

	function COXYMallPortfolio() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		switch ($_GET["sub"]) {
			case "oxymall.plugin.portfolio.landing":
				return $this->GeneratePage();
			break;

			case "oxymall.plugin.portfolio.project":
				return $this->GenerateProjectPage();
			break;
		}
	}

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/portfolio/";

		$templates = array(
			"projects" => "projects.htm",
			"project" => "project.htm",
			"simple" => "simple.htm",
			"side" => "side.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}

	function GenerateProjectPage() {
		global $base , $_TSM;
		$this->__init();

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();

		$project = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:portfolio_projects']} WHERE project_id='{$_GET[project]}' AND module_id='{$this->tpl_module[mod_id]}'");

		if (!is_array($project)) {
			urlredirect($this->tpl_module["mod_url"]);
		}
		
		$this->module->plugins["modules"]->SetSeo($project);
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo($this->tpl_module);
		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				$project["project_title"]	=> "",
			)
		);

		$next = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:portfolio_projects']},{$this->tables['plugin:portfolio_cats']} as c WHERE project_cat=cat_id AND cat_id={$project[project_cat]} AND project_order > {$project[project_order]} AND c.module_id='{$this->tpl_module[mod_id]}' ORDER BY project_order ASC LIMIT 1");
		$prev = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:portfolio_projects']},{$this->tables['plugin:portfolio_cats']} as c WHERE project_cat=cat_id AND cat_id={$project[project_cat]} AND project_order < {$project[project_order]} AND c.module_id='{$this->tpl_module[mod_id]}' ORDER BY project_order DESC LIMIT 1");


		//process the galleries
		$photos = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:portfolio_items']} WHERE item_project={$project[project_id]} ORDER BY item_order ASC" );

		if (is_Array($photos)) {
			foreach ($photos as $key => $val) {
				switch ($val["item_type"]) {
					case "1":
						$photos[$key]["source"] = $_CONF["url"] . "upload/portfolio/{$val[item_id]}.jpg";
					break;

					case "4":
						$photos[$key]["source"] = $val["item_youtube"];
					break;

					case "5":
						$photos[$key]["source"] = $_CONF["url"] . "upload/portfolio/{$val[item_id]}.swf";
					break;
				}
			}
			
			$project["image"] = $base->html->Table(
				$this->private->templates["project"],
				"",
				$photos
			);
		} else 
			$project["image"] = "";
		

		return CTemplateStatic::Replace(
			$this->private->templates["project"]->blockReplace(
				"Main" ,
				array_merge(
					$project,
					array(
						"next_link" => $next ? $this->private->templates["project"]->Blockreplace("Next" , $next) : "",
						"prev_link" => $prev ? $this->private->templates["project"]->Blockreplace("Prev" , $prev) : "",

						"sidebar"	=> $this->SideBar(),
					)
				)				
			),
			$this->tpl_module
		);		
	}
	
	function GeneratePage() {
		global $base , $_TSM;
		$this->__init();

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();

		//simple display page, for more complex portfolio get the code from other templates

		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo($this->tpl_module);
		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"]	. "/"
			)
		);

		//get all categories
		$cats = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:portfolio_cats']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY cat_order ASC"
		);

		if (is_array($cats)) {
			foreach ($cats as $key => $val) {
				$projects = $this->db->QFetchRowArray(
					"SELECT * FROM {$this->tables['plugin:portfolio_projects']} WHERE project_cat={$val[cat_id]} ORDER BY project_order ASC"
				);

				if (is_array($projects)) {
					$cnt = 1;
					foreach ($projects as $k => $v) {
						$projects[$k]["cnt"] = $cnt;

						$projects[$k]["extra"] = $cnt == 3 ? $this->private->templates["simple"]->blockReplace("ProjectsExtra" , array()) : "";

						if ($cnt == 3) {
							$cnt = 1;
						} else 						
							$cnt ++;
					}					
				}
				

				$cats[$key]["projects"] = CTemplateStatic::ReplacE(
					$base->html->Table(
						$this->private->templates["simple"],
						"Projects",
						$projects
					),
					array(
						"mod_url"	=> $this->tpl_module["mod_url"],
						"cat_url"	=> $val["cat_url"],
					)
				);
			}			
		}
		


		return CTemplateStatic::Replace(
			$this->private->templates["simple"]->BlockReplace(
				"Main",
				array(

					"categories" => $base->html->table(
						$this->private->templates["simple"],
						"Cats",
						$cats
					),

				)
			),
			array_merge(
				$this->tpl_module,
				(array)$category
			)
		);

	}

	/**
	* description
	*
	* @param
	*
	* @return
	*
	* @access
	*/
	function SideBar() {
		global $base;

		//get all categories
		$cats = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:portfolio_cats']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY cat_order ASC"
		);

		if (is_array($cats)) {
			foreach ($cats as $key => $val) {
				$projects = $this->db->QFetchRowArray(
					"SELECT * FROM {$this->tables['plugin:portfolio_projects']} WHERE project_cat={$val[cat_id]} ORDER BY project_order ASC"
				);

				$cats[$key]["projects"] = CTemplateStatic::ReplacE(
					$base->html->Table(
						$this->private->templates["side"],
						"Projects",
						$projects
					),
					array(
						"mod_url"	=> $this->tpl_module["mod_url"],
						"cat_url"	=> $val["cat_url"],
						"title"		=> $val["cat_title"],
					)
				);
			}			
		}
		


		return $base->html->table(
			$this->private->templates["side"],
			"Cats",
			$cats
		);
	}
	

		
	function GetAllLinks($module , $links) {

		$items = $this->db->QFetchRowArray(
			"SELECT * " . "FROM {$this->tables['plugin:portfolio_projects']},{$this->tables['plugin:portfolio_cats']} as c " . 
			"WHERE " ." c.module_id={$module[mod_id]} and cat_id=project_cat "
		);

		if (is_array($items)) {

			foreach ($items as $key => $val) {
				$links[] = array(
					"url" => $module["mod_url"] . "/" . $val["cat_url"] . "/" . $val["project_url"] . "-" . $val["project_id"] . "/",
					"priority"	=> "0.6",
				);
			}			
		}

	}


}

?>