<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallTestimonials extends CPlugin{
	
	var $tplvars; 

	function COXYMallTestimonials() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		if ($_GET["sub"] == "oxymall.plugin.testimonials.landing") {
			return $this->GeneratePage();
		}
	}	

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/testimonials/";

		$templates = array(
			"testimonials" => "testimonials.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}


	function GeneratePage() {
		global $base , $_TSM;

		$this->__init();
		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();
				
		$quotes = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:testimonials']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY item_order ASC"
		);

		if (is_array($quotes)) {
			$count = 0;
			foreach ($quotes as $key => $val) {
				$quotes[$key]["class"] = $count ? "right" : "left";
				$count = !$count;
			}			
		}	

		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module			
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"]	. "/"			
			)
		);

		return $this->private->templates["testimonials"]->BlockReplace(
			"Main",
			array(
				"header"	=> $this->vars->data["testimonials_header_" . $this->tpl_module["mod_id"]],
				"title"	=> $this->tpl_module["mod_long_name"],

				"quotes"	=> $base->html->table(
					$this->private->templates["testimonials"],
					"Quotes",
					$quotes
				)

				
			)
		);
	}

	function GetAllLinks($module , $links) {
	}

}

?>