<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallBlog extends CPlugin{
	
	var $tplvars; 

	function COXYMallBlog() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		if (strstr($_GET["sub"] , "oxymall.plugin.blog.")) {
			$sub = str_replace("oxymall.plugin.blog." , "" ,$_GET["sub"]);
			$action = $_GET["action"];

			//read the module
			$this->tpl_module = $this->module->plugins["modules"]->getModuleInfo($_GET["module_id"]);

			switch ($sub) {
				case "landing":
					$data = new CSQLAdmin("blog/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);
					$this->PrepareFields(&$data->forms["forms"]);
					return $data->DoEvents();
				break;

				case "comments":
					$data = new CSQLAdmin("blog/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);
					$this->PrepareFields(&$data->forms["forms"]);
					return $data->DoEvents();
				break;


				case "cats":

					if (($_GET["action"] == "moveup") || ($_GET["action"] == "movedown")) {
						$this->__call_reorder_cats($_GET["action"]);
					}
					
					$data = new CSQLAdmin("blog/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);

					$this->PrepareFields(&$data->forms["forms"], $sub);

					$data->functions = array( 
							"onstore" => array(&$this , "StoreCat"),
					);					

					return $data->DoEvents();

				break;

				case "authors":
					$data = new CSQLAdmin("blog/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);
					$this->PrepareFields(&$data->forms["forms"], $sub);
					return $data->DoEvents();
				break;

				case "pages":

					if (($_GET["action"] == "moveup") || ($_GET["action"] == "movedown")) {
						$this->__call_reorder_pages($_GET["action"]);
					}
					
					$data = new CSQLAdmin("blog/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);

					$this->PrepareFields(&$data->forms["forms"], $sub);

					$data->functions = array( 
							"onstore" => array(&$this , "StorePage"),
					);					

					return $data->DoEvents();

				break;


			}
		}
	}


	function PrepareFields($forms) {
		$forms["list"]["title"] = CTemplateStatic::Replace(
			$forms["list"]["title"],
			array( "title" => $this->tpl_module["mod_name"])
		);

		$forms["edit"]["title"] = CTemplateStatic::Replace(
			$forms["edit"]["title"],
			array( "title" => $this->tpl_module["mod_name"])
		);

		$forms["add"]["title"] = CTemplateStatic::Replace(
			$forms["add"]["title"],
			array( "title" => $this->tpl_module["mod_name"])
		);

		if (is_Array($forms["search"])) {
			$forms["search"]["title"] = CTemplateStatic::Replace(
				$forms["search"]["title"],
				array( "title" => $this->tpl_module["mod_name"])
			);
		}
		
	}
	

	function StoreCat($record) {
		if ($record["cat_id"] && !$record["cat_order"]) {
			$this->db->QueryUpdate(
				$this->tables["plugin:blog_cats"],
				array(
					"cat_order" => $record["cat_id"]
				),
				"cat_id='{$record[cat_id]}'"
			);
		}		
	}
	

	function __call_reorder_cats($action) {

		$sql = "SELECT * FROM {$this->tables['plugin:blog_cats']} WHERE module_id={$this->tpl_module[mod_id]} AND cat_order " . ($_GET["action"] == "moveup" ? " <= " : " >= " ) . " '{$_GET[cat_order]}' ORDER BY cat_order " . ($_GET["action"] == "moveup" ? " DESC " : " ASC " ) . " LIMIT 2 " ;

		$rows = $this->db->QFetchRowArray($sql);

		if (count($rows) == 2) {

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:blog_cats'],
						array(
							"cat_order" => $rows[1]["cat_order"]
						),
						" cat_id='{$rows[0][cat_id]}'"
					);

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:blog_cats'],
						array(
							"cat_order" => $rows[0]["cat_order"]
						),
						" cat_id='{$rows[1][cat_id]}'"
					);
		}

		//debug($_SERVER);

		UrlRedirect($_SERVER["HTTP_REFERER"]);
		die;
	}


	function StorePage($record) {
		if ($record["item_id"] && !$record["item_order"]) {
			$this->db->QueryUpdate(
				$this->tables["plugin:blog_pages"],
				array(
					"item_order" => $record["item_id"]
				),
				"item_id='{$record[item_id]}'"
			);
		}		
	}
	

	
	function __call_reorder_pages($action) {
		$sql = "SELECT * FROM {$this->tables['plugin:blog_pages']} WHERE module_id={$this->tpl_module[mod_id]} AND item_order " . ($_GET["action"] == "moveup" ? " <= " : " >= " ) . " '{$_GET[item_order]}' ORDER BY item_order " . ($_GET["action"] == "moveup" ? " DESC " : " ASC " ) . " LIMIT 2 " ;

		$rows = $this->db->QFetchRowArray($sql);

		if (count($rows) == 2) {

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:blog_pages'],
						array(
							"item_order" => $rows[1]["item_order"]
						),
						" item_id='{$rows[0][item_id]}'"
					);

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:blog_pages'],
						array(
							"item_order" => $rows[0]["item_order"]
						),
						" item_id='{$rows[1][item_id]}'"
					);
		}

		//debug($_SERVER);

		UrlRedirect($_SERVER["HTTP_REFERER"]);
		die;
	}

}

?>