<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallFaq extends CPlugin{
	
	var $tplvars; 

	function COXYMallFaq() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;


		parent::DoEvents();


		if (strstr($_GET["sub"] , "oxymall.plugin.faq.")) {
			$sub = str_replace("oxymall.plugin.faq." , "" ,$_GET["sub"]);
			$action = $_GET["action"];

			//read the module
			$this->tpl_module = $this->module->plugins["modules"]->getModuleInfo($_GET["module_id"]);

			switch ($sub) {

				case "landing":

					urlredirect("index.php?mod=oxymall&sub=oxymall.plugin.faq.items&module_id={$_GET[module_id]}");

				break;

				case "items":
					if (($_GET["action"] == "moveup") || ($_GET["action"] == "movedown")) {
						$this->__call_reorder_items($_GET["action"]);
					}
					
					$data = new CSQLAdmin("faq/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);
					$this->PrepareFields(&$data->forms["forms"] , $sub);

					$data->functions = array( 
							"onstore" => array(&$this , "__call_store_items"),
					);					

					return $data->DoEvents();
				break;

			}
		}
	}

	function PrepareFields($forms , $sub) {

		if (is_array($forms["search"])) {
			$forms["search"]["title"] = CTemplateStatic::Replace(
				$forms["search"]["title"],
				array( "module_title" => $this->tpl_module["mod_name"])
			);
		}

		if (is_array($forms["list"])) {
			$forms["list"]["title"] = CTemplateStatic::Replace(
				$forms["list"]["title"],
				array( "module_title" => $this->tpl_module["mod_name"])
			);
		}

		if (is_array($forms["edit"])) {
			$forms["edit"]["title"] = CTemplateStatic::Replace(
				$forms["edit"]["title"],
				array( "module_title" => $this->tpl_module["mod_name"])
			);
		}

		if (is_array($forms["add"])) {
			$forms["add"]["title"] = CTemplateStatic::Replace(
				$forms["add"]["title"],
				array( "module_title" => $this->tpl_module["mod_name"])
			);
		}

		if (is_array($forms["details"])) {
			$forms["details"]["title"] = CTemplateStatic::Replace(
				$forms["details"]["title"],
				array( "module_title" => $this->tpl_module["mod_name"])
			);
		}
	}
	

	function __call_store_items($record) {
		if ($record["item_id"] && !$record["item_order"]) {
			$this->db->QueryUpdate(
				$this->tables["plugin:faq_items"],
				array(
					"item_order" => $record["item_id"]
				),
				"item_id='{$record[item_id]}'"
			);
		}		
	}

	function __call_reorder_items($action) {

		$item = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:faq_items']} WHERE item_id='{$_GET[item_id]}' ");

		$sql = "SELECT * FROM {$this->tables['plugin:faq_items']} WHERE module_id={$this->tpl_module[mod_id]}  AND item_order " . ($_GET["action"] == "moveup" ? " <= " : " >= " ) . " '{$_GET[item_order]}' ORDER BY item_order " . ($_GET["action"] == "moveup" ? " DESC " : " ASC " ) . " LIMIT 2 " ;



		$rows = $this->db->QFetchRowArray($sql);

		if (count($rows) == 2) {

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:faq_items'],
						array(
							"item_order" => $rows[1]["item_order"]
						),
						" item_id='{$rows[0][item_id]}'"
					);

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:faq_items'],
						array(
							"item_order" => $rows[0]["item_order"]
						),
						" item_id='{$rows[1][item_id]}'"
					);
		}

		//debug($_SERVER);

		UrlRedirect($_SERVER["HTTP_REFERER"]);
		die;
	}
	
	

}

?>