<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallPortfolio extends CPlugin{
	
	var $tplvars; 

	function COXYMallPortfolio() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		if (strstr($_GET["sub"] , "oxymall.plugin.portfolio.")) {
			$sub = str_replace("oxymall.plugin.portfolio." , "" ,$_GET["sub"]);
			$action = $_GET["action"];

			//read the module
			$this->tpl_module = $this->module->plugins["modules"]->getModuleInfo($_GET["module_id"]);

			switch ($sub) {

				case "landing":
				case "projects":

					if (($_GET["action"] == "moveup") || ($_GET["action"] == "movedown")) {
						$this->__call_reorder_projects($_GET["action"]);
					}

					if ($_GET["action"] == "details") {
						$data = new CSQLAdmin("portfolio/images" , $this->__parent_templates,$this->db,$this->tables,$extra);
						$extra["details"]["after"] = $data->DoEvents();
					}

					
					$data = new CSQLAdmin("portfolio/landing", $this->__parent_templates,$this->db,$this->tables,$extra);

					$this->PrepareFields(&$data->forms["forms"] , $sub);

					$data->functions = array( 
							"onstore" => array(&$this , "StoreProject"),
					);					

					return $data->DoEvents();

				break;

				case "cats":

					if (($_GET["action"] == "moveup") || ($_GET["action"] == "movedown")) {
						$this->__call_reorder_cats($_GET["action"]);
					}
					
					$data = new CSQLAdmin("portfolio/cats", $this->__parent_templates,$this->db,$this->tables,$extra);

					$this->PrepareFields(&$data->forms["forms"]);

					$data->functions = array( 
							"onstore" => array(&$this , "StoreCat"),
					);					

					return $data->DoEvents();

				break;

				case "images":

					if (($_GET["action"] == "moveup") || ($_GET["action"] == "movedown")) {
						$this->__call_reorder_images($_GET["action"]);
					}
					
					$data = new CSQLAdmin("portfolio/" . $sub, $this->__parent_templates,$this->db,$this->tables,$extra);

					$this->PrepareFields(&$data->forms["forms"] , $sub);

					$data->functions = array( 
							"onstore" => array(&$this , "StoreImage"),
					);					

					return $data->DoEvents();

				break;

			}
		}
	}

	function PrepareFields($forms , $sub = "") {

		if (is_array($forms["search"])) {
			$forms["search"]["title"] = CTemplateStatic::Replace(
				$forms["search"]["title"],
				array( "title" => $this->tpl_module["mod_name"])
			);
		}

		if (is_array($forms["details"])) {
			$forms["details"]["title"] = CTemplateStatic::Replace(
				$forms["details"]["title"],
				array( "title" => $this->tpl_module["mod_name"])
			);
		}

		$forms["list"]["title"] = CTemplateStatic::Replace(
			$forms["list"]["title"],
			array( "title" => $this->tpl_module["mod_name"])
		);

		$forms["edit"]["title"] = CTemplateStatic::Replace(
			$forms["edit"]["title"],
			array( "title" => $this->tpl_module["mod_name"])
		);

		$forms["add"]["title"] = CTemplateStatic::Replace(
			$forms["add"]["title"],
			array( "title" => $this->tpl_module["mod_name"])
		);
	}
	


	function StoreProject($record) {
		if ($record["project_id"] && !$record["project_order"]) {
			$this->db->QueryUpdate(
				$this->tables["plugin:portfolio_projects"],
				array(
					"project_order" => $record["project_id"]
				),
				"project_id='{$record[project_id]}'"
			);
		}		
	}
	

	function __call_reorder_projects($action) {

		$project = $this->db->QFetchArray("SELECT *FROM {$this->tables['plugin:portfolio_projects']} WHERE project_id='{$_GET[project_id]}'");

		$sql = "SELECT * FROM {$this->tables['plugin:portfolio_projects']} WHERE project_cat={$project[project_cat]} AND module_id={$this->tpl_module[mod_id]} AND project_order " . ($_GET["action"] == "moveup" ? " <= " : " >= " ) . " '{$_GET[project_order]}' ORDER BY project_order " . ($_GET["action"] == "moveup" ? " DESC " : " ASC " ) . " LIMIT 2 " ;

		$rows = $this->db->QFetchRowArray($sql);

		if (count($rows) == 2) {

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:portfolio_projects'],
						array(
							"project_order" => $rows[1]["project_order"]
						),
						" project_id='{$rows[0][project_id]}'"
					);

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:portfolio_projects'],
						array(
							"project_order" => $rows[0]["project_order"]
						),
						" project_id='{$rows[1][project_id]}'"
					);
		}

		//debug($_SERVER);

		UrlRedirect($_SERVER["HTTP_REFERER"]);
		die;
	}


	function StoreCat($record) {
		if ($record["cat_id"] && !$record["cat_order"]) {
			$this->db->QueryUpdate(
				$this->tables["plugin:portfolio_cats"],
				array(
					"cat_order" => $record["cat_id"]
				),
				"cat_id='{$record[cat_id]}'"
			);
		}		
	}
	

	function __call_reorder_cats($action) {

		$sql = "SELECT * FROM {$this->tables['plugin:portfolio_cats']} WHERE module_id={$this->tpl_module[mod_id]} AND cat_order " . ($_GET["action"] == "moveup" ? " <= " : " >= " ) . " '{$_GET[cat_order]}' ORDER BY cat_order " . ($_GET["action"] == "moveup" ? " DESC " : " ASC " ) . " LIMIT 2 " ;

		$rows = $this->db->QFetchRowArray($sql);

		if (count($rows) == 2) {

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:portfolio_cats'],
						array(
							"cat_order" => $rows[1]["cat_order"]
						),
						" cat_id='{$rows[0][cat_id]}'"
					);

			//insert the new values
			$this->db->QueryUpdate(
						$this->tables['plugin:portfolio_cats'],
						array(
							"cat_order" => $rows[0]["cat_order"]
						),
						" cat_id='{$rows[1][cat_id]}'"
					);
		}

		//debug($_SERVER);

		UrlRedirect($_SERVER["HTTP_REFERER"]);
		die;
	}


}

?>