<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallMail extends CPlugin{
	
	var $tplvars; 

	function COXYMallMail() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();
	}

	/**
	* description
	*
	* @param
	*
	* @return
	*
	* @access
	*/
	function SendMail() {

		$params = AStripSlasshes(func_get_args());	
		//check to see the numbers of the arguments

		switch (func_num_args()) {
			case 1:
				$email = $params[0];
				$vars = array();
			break;

			case 2:
				$email = $params[0];
				$vars = $params[1];
			break;

			case 3:
				$to = $params[0];
				$email = $params[1];
				$vars = $params[2];
			break;

			case 4:
				$to = $params[0];
				$to_name = $params[1];
				$email = $params[2];
				$vars = $params[3];
			break;
		}
				
		$msg = new CTemplate(stripslashes($email["email_body"]) , "string");
		$msg = $msg->Replace($vars);

		$sub = new CTemplate(stripslashes($email["email_subject"]) , "string");
		$sub = $sub->Replace($vars);

		$email["email_from"] = new CTemplate(stripslashes($email["email_from"]) , "string");
		$email["email_from"] = $email["email_from"]->Replace($vars);

		$email["email_from_name"] = new CTemplate(stripslashes($email["email_from_name"]) , "string");
		$email["email_from_name"] = $email["email_from_name"]->Replace($vars);

		if (!$email["email_reply"]) 
			$email["email_reply"] = $email["email_from"];
		if (!$email["email_reply_name"]) 
			$email["email_reply_name"] = $email["email_from_name"];


		if ($this->vars->data["set_switft_transport"] == "php-default") {
			$headers  = "MIME-Version: 1.0\r\n";

			if ($email["email_type"] == "html")
				$headers .= "Content-type: text/html\r\n";
			else
				$headers .= "Content-type: text/plain\r\n";

			//prepare the from fields
			if (!$email["email_hide_from"]) {
				$headers .= "From: {$email[email_from_name]}<{$email[email_from]}>\r\n";
				$headers .=	"Reply-To: {$email[email_reply_name]}<{$email[email_reply]}>\r\n";
			}

			$headers .= $email["headers"];
		
			if (!$email["email_hide_to"]) {
				return mail($email["email_to"] , $sub, $msg,$headers);		
			} else {
			}

			$headers .=	"X-Mailer: PHP/" . phpversion();

			return mail($to, $sub, $msg,$headers);				

		} else {

			require_once _LIBPATH . '../3rdparty/swift-4/swift_required.php'; 

			$recipients = array($email["email_to"] => $email["email_to_name"] ? $email["email_to_name"] : $email["email_to"]);	
			$from = array($email["email_from"] => $email["email_from_name"] ? $email["email_from_name"] : $email["email_from"]);	
			$body = $msg;
			$subject = $sub;
		
			//initialize the mail sending
			switch ($this->vars->data["set_switft_transport"]) {
				case "smtp":
					$transport = Swift_SmtpTransport::newInstance(
						$this->vars->data["set_swiftp_smtp_server"],
						$this->vars->data["set_swiftp_smtp_port"]
					);

					if ($this->vars->data["set_swiftp_smtp_auth"]) {
						$transport->setUsername($this->vars->data["set_swiftp_smtp_auth_username"]);
						$transport->setPassword($this->vars->data["set_swiftp_smtp_auth_password"]);
					}
					
					switch ($this->vars->data["set_swiftp_smtp_enc"]) {
						case "ssl":
							$transport->setEncryption("ssl");
						break;

						case "tls":
							$transport->setEncryption("tls");
						break;
					}
				break;

				case "sendmail":
					$transport = Swift_SmtpTransport::newInstance(
						$this->vars->data["set_swiftp_sendmail"]
					);
				break;
		
				case "php":
					$transport = Swift_SmtpTransport::newInstance();
				break;
			}
			
			
			$message = Swift_Message::newInstance($subject);
			$message->setBody(
				$body , 
				"text/html"
			);

			$message->setTo($recipients);

			$message->setFrom($from);

			$mailer = Swift_Mailer::newInstance($transport);
			$result = $mailer->send($message);

			//$message->setReadReceiptTo('emanuel@oxylus.ro');

			return true;
		}
	}
}

?>