<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallNews extends CPlugin{
	
	var $tplvars; 

	function COXYMallNews() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();
	
		switch ($_GET["sub"]) {
			case "oxymall.plugin.news.item":
				return $this->NewsDetails();
		break;

			case "oxymall.plugin.news.landing":
				return $this->NewsList();
			break;
		}
		
	}

	function NewsList() {
		global $base , $_TSM;
		$this->__init();

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);		

		$this->__init();


		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module			
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"]	. "/"			
			)
		);


		$items = $this->GetItems($this->tpl_module["settings"]["set_items"], $_GET["page"]);

		if (is_Array($items["records"])) {
			foreach ($items["records"] as $key => $val) {
				$items["records"][$key]["image"] = $val["item_image"] ? $this->private->templates["list"]->Blockreplace(
						"BriefImage",
						$val
					) : "";

				$items["records"][$key]["date"]	= date($this->tpl_module["settings"]["set_date_format"] , $val["item_date"]);
			}
			
		}
		

		return CTemplateStatic::Replace(
			$this->private->templates["list"]->BlockReplace(
				"Main",
				array(

					"items"	=> CTemplateStatic::Replace(
						$base->html->table(
							$this->private->templates["list"],
							"",
							$items["records"]
						),
						array(
							
						)
					),

					"paging"=> $this->module->plugins["paging"]->Paging(
						$items["pages"] , 
						$items["page"], 
						array(
							"first" => $this->tpl_module["mod_url"] . "/",
							"all" => $this->tpl_module["mod_url"] . "/{PAGE}/",
						)
					),

				)
			),
			$this->tpl_module
		);

	}

	function NewsDetails() {
		global $_TSM , $_CONF;

		$this->__init();

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();

		//get the news
		$item = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:news_items']} WHERE item_id='{$_GET[topic]}' AND module_id={$this->tpl_module[mod_id]}");

		if (!is_array($item)) {
			urlredirect($_CONF["url"] . $this->tpl_module["mod_url"] . "/");
		}
		


		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module			
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"]	. "/",
				$item["item_title"] => $this->tpl_module["mod_url"]	. "/" . $item["item_url"] . "-" . $item["item_id"] . "/"
			)
		);



		$this->module->plugins["modules"]->SetSeo($item);		
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);		


		$item["image"] = $item["item_image"] ? $this->private->templates["list"]->Blockreplace(
				"BriefImage",
				$item
			) : "";

		$item["date"]	= date($this->tpl_module["settings"]["set_date_format"] , $item["item_date"]);

		$item["mod_url"] = $this->tpl_module["mod_url"];

		return $this->private->templates["details"]->blockReplace(
			"Main" , 
			$item
		);

	}
	

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/news/";

		$templates = array(
			"list"		=> "list.htm",
			"details"	=> "details.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}

	function getItems($count = 10, $page = 1 ) {

		$page = (int)$page ? $page : 1;

		$fields = "*";
		
		$items = $this->db->QFetchRowArray(
			"SELECT {$fields} " . 
			"FROM {$this->tables['plugin:news_items']} " . 
			"WHERE " . 
			"module_id={$this->tpl_module[mod_id]} " . 
			"ORDER BY  item_date DESC " . 
			"LIMIT " . ( ($page - 1 ) * $count ) . " , " . $count 
		);
		

		//get the elements count
		$items_count = $this->db->RowCount(
			$this->tables['plugin:news_items'],
			"WHERE " . 
			"module_id={$this->tpl_module[mod_id]} "
		);
		
		return array(
			"records"	=> $items , 
			"count"		=> $items_count , 
			"pages"		=> $items_count ? ceil($items_count / $count) : 1,
			"page"		=> $page,
		);		
	}


	function GetAllLinks($module , $links) {

		$items = $this->db->QFetchRowArray(
			"SELECT * " . "FROM {$this->tables['plugin:news_items']} " . 
			"WHERE " . "module_id={$module[mod_id]} "
		);

		if (is_array($items)) {

			foreach ($items as $key => $val) {
				$links[] = array(
					"url" => $module["mod_url"] . "/" . $val["item_url"] . "-" . $val["item_id"] . "/",
					"priority"	=> "0.6",
				);
			}			
		}


	}

	function GetLatestRecords($module , $count = 5) {
		$items = $this->db->QFetchRowArray(
			"SELECT item_id, item_title,item_url,item_date " . "FROM {$this->tables['plugin:news_items']} " . 
			"WHERE " . "module_id={$module[mod_id]} " . 
			"ORDER BY item_date DESC " . 
			"LIMIT $count "
		);

		return $items;
	}
	

}

?>