<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallProducts extends CPlugin{	
	
	var $tplvars; 

	function COXYMallProducts() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();
		
		if (stristr($_GET["sub"] , "oxymall.plugin.products")) {
			$sub = str_replace("oxymall.plugin.products." , "" , $_GET["sub"]);

			$this->__init();
			$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();

			$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
				$this->tpl_module,
				"",
				$this->private->templates["side"]->blockReplace("SearchHeader" , array("mod_url" => $this->tpl_module["mod_url"]))
			);
			
			switch ($sub) {
				case "landing":
					return $this->Landing();
				break;

				case "category":
					return $this->Category();
				break;

				case "product":
					return $this->Product();
				break;

				case "search":
					return $this->Search();
				break;

				case "add-cart":
					return $this->AddToCart();
				break;


			}
		}
	}

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/products/";

		$templates = array(
			"landing-categories"	=> "landing-categories.htm",
			"landing-products"		=> "landing-products.htm",
			"category"				=> "category.htm",
			"search"				=> "search.htm",
			"side"					=> "side.htm",
			"products"				=> "products.htm",
			"product"				=> "product.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}

	function Landing() {
		global $_TSM;

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/"
			)
		);

		switch ($this->tpl_module["settings"]["set_landing_type"]) {

			//categories page
			case "2":
				return $this->landingCategories();
			break;

			case "1":
				return $this->landingProducts();
			break;

			case "3":
				//get the first category 
				$cat = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:shop_cats']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY cat_order ASC LIMIT 1");

				//force the cat
				$_GET["category"]  = $cat["cat_url"];

				return $this->Category();
			break;
		}
		
	}

	function LandingCategories() {
		global $base;

		$categories = $this->__bk_get_categories();

		if (is_array($categories)) {
			$count = 1;
			
			foreach ($categories as $key => $val) {
	
				if ($count != 3) {
					$categories[$key]["class"] = "";
					$categories[$key]["extra"] = "";
				} else {
				
					$categories[$key]["class"] = $this->private->templates["landing-categories"]->BlockReplace("class-last" , $val);
					$categories[$key]["extra"] = $this->private->templates["landing-categories"]->BlockReplace("Extra" , $val);
				}

				if ($count <=3) {						
					$count ++;
				} else {
					$count = 2;
				}

			}

		}
		

		return CTemplateStatic::Replace(
			$this->private->templates["landing-categories"]->blockReplace(
				"Main",
				array(
					"categories"	=> $base->html->Table(
						$this->private->templates["landing-categories"],
						"",
						$categories
					),

					"left_widget"	=> $this->Widget($this->tpl_module["settings"]["set_landing_category_widget_1"]),
					"center_widget"	=> $this->Widget($this->tpl_module["settings"]["set_landing_category_widget_2"]),
					"right_widget"	=> $this->Widget($this->tpl_module["settings"]["set_landing_category_widget_3"]),
				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"],
				"subtitle"	=> $this->tpl_module["settings"]["set_subtitle"] ? $this->private->templates["landing-categories"]->blockReplace("Subtitle" , $this->tpl_module["settings"]) : ""
			)
		);
	}

	function LandingProducts() {
		global $base, $_TSM;

		
		//read the products 
		$products = $this->__bk_get_all_products( $this->tpl_module["settings"]["set_items_all"] , $_GET["page"]);

		$products["records"] = $this->ProcessProducts($products["records"] , 3);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
			)
		);



		return CTemplateStatic::replace(
			$this->private->templates["landing-products"]->blockReplace(
				"Main",
				array(
					"sidebar"		=> $this->SideMenu($this->tpl_module["settings"]["set_landing_products_side"]),
					"subtitle"	=> $this->tpl_module["settings"]["set_subtitle"] ? $this->private->templates["landing-products"]->Blockreplace(
						"Subtitle",
						$this->tpl_module["settings"]
					) : "",
					"content"	=> $this->private->templates["landing-products"]->blockReplace(
						"Products", 
						array(
							"items" => $base->html->Table(
								$this->private->templates["products"],	
								"",		
								$products["records"]
							),

							"paging"=> $this->module->plugins["paging"]->Paging(
								$products["pages"] , 
								$products["page"], 
								array(
									"first" => $this->tpl_module["mod_url"] . "/",
									"all" => $this->tpl_module["mod_url"] . "/{PAGE}/",
								)
							),


						)
					),

					"left_widget"	=> $this->Widget($this->tpl_module["settings"]["set_landing_products_widget_1"]),
					"right_widget"	=> $this->Widget($this->tpl_module["settings"]["set_landing_products_widget_2"]),

				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);
	}


	function Search() {
		global $base, $_TSM;

		//read the products 
		$products = $this->__bk_search_products($_GET["q"], $this->tpl_module["settings"]["set_items_search"] , $_GET["page"]);

		$products["records"] = $this->ProcessProducts($products["records"] , 3);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				"Search Results" => "",
			)
		);



		return CTemplateStatic::replace(
			$this->private->templates["search"]->blockReplace(
				"Main",
				array(
					"title"	=> CTemplateStatic::Replace(
						$this->tpl_module["settings"]["set_search_title"],
						array(
							"q"	=> stripslashes($_GET["q"])
						)
					),
					"sidebar"		=> $this->SideMenu($this->tpl_module["settings"]["set_search_side"]),
					"content"		=> $this->private->templates["search"]->blockReplace(
						"Products", 
						array(
							"items" => $base->html->Table(
								$this->private->templates["products"],	
								"",		
								$products["records"]
							),
							"title"	=> $category["cat_title"],

							"paging"=> $this->module->plugins["paging"]->Paging(
								$products["pages"] , 
								$products["page"], 
								array(
									"first" => $this->tpl_module["mod_url"] . "/search/?q={$_GET[q]}",
									"all" => $this->tpl_module["mod_url"] . "/search/?q={$_GET[q]}&page={PAGE}",
								)
							),

						)
					),

					"left_widget"	=> $this->Widget($this->tpl_module["settings"]["set_search_widget_1"]),
					"right_widget"	=> $this->Widget($this->tpl_module["settings"]["set_search_widget_2"]),
				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);
	}


	function Category() {
		global $base, $_TSM;

		$category = $this->__bk_get_category($_GET["category"]);

		if (!is_array($category)) {
			urlredirect($this->tpl_module["mod_url"]);
		}
		
		//read the products 
		$products = $this->__bk_get_category_products($category , $this->tpl_module["settings"]["set_items_category"] , $_GET["page"]);

		$products["records"] = $this->ProcessProducts($products["records"] , 3);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				$category["cat_title"] => $this->tpl_module["mod_url"] . "/" . $category["cat_url"] . "/"
			)
		);



		return CTemplateStatic::replace(
			$this->private->templates["category"]->blockReplace(
				"Main",
				array(
					"sidebar"		=> $this->SideMenu($this->tpl_module["settings"]["set_category_side"]),
					"content"		=> $this->private->templates["category"]->blockReplace(
						"Products", 
						array(
							"items" => $base->html->Table(
								$this->private->templates["products"],	
								"",		
								$products["records"]
							),
							"title"	=> $category["cat_title"],

							"paging"=> $this->module->plugins["paging"]->Paging(
								$products["pages"] , 
								$products["page"], 
								array(
									"first" => $this->tpl_module["mod_url"] . "/" . $category["cat_url"] . "/",
									"all" => $this->tpl_module["mod_url"] . "/" . $category["cat_url"] . "/{PAGE}/",
								)
							),


						)
					),

					"left_widget"	=> $this->Widget($this->tpl_module["settings"]["set_category_widget_1"]),
					"right_widget"	=> $this->Widget($this->tpl_module["settings"]["set_category_widget_2"]),

				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);
	}

	function SideMenu($side) {

		if (!trim($side)) {
			return "";
		}

		$side = explode("\n" , $side);

		if (is_Array($side)) {
			foreach ($side as $key => $val) {
				$val = trim($val);

				switch ($val) {
					case "search":
						$content .= $this->SideMenuSearch();
					break;

					case "categories":
						$content .= $this->SideMenuCategories();
					break;

					case "latest_products":
						$content .= $this->SideMenuLatestProducts();
					break;

					case "last_visited":
						$content .= $this->SideMenuLastVisited();
					break;

					case "best_sold":
						$content .= $this->SideMenuBestSold();
					break;

					case "related_products":
						$content .= $this->SideMenuRelated();
					break;

					case "last_sold":
						$content .= $this->SideMenuLastSold();
					break;

					case "featured_product":
						$content .= $this->SideMenuFeatured();
					break;

				}				
			}			

			return $content;
		}
		
		

		return CTemplateStatic::Replace(
			$this->tpl_module["settings"]["set_sidebar"],
			array(
				"search"			=> $this->SideMenuSearch(),
				"categories"		=> $this->SideMenuCategories(),
				"latest_products"	=> $this->SideMenuLatestProducts(),
				"last_visited"		=> $this->SIdeMenuLastVisited(),
				"related"			=> $this->SIdeMenuRelated(),
			)
		);
	}

	function SideMenuSearch() {
		return $this->private->templates["side"]->blockReplace(
			"Search",
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);
	}

	

	function SideMenuCategories() {
		global $base;

		$categories = $this->__bk_get_categories();

		return CTemplateStatic::Replace(
			$base->html->table(
				$this->private->templates["side"],
				"Cats",
				$categories
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"],
				"title"		=> $this->tpl_module["settings"]["set_widget_categories"]
			)
		);
	}
	
	function SideMenuLatestProducts($product = false) {
		global $base;

		$products = $this->__bk_get_products($this->tpl_module["settings"]["set_widget_latest_products_items"],"item_date DESC");

		return CTemplateStatic::Replace(
			$this->private->templates["side"]->blockreplace(
				($product ? "FooterWidget": "SideWidget" ),
				array(	
					"products"	=> $base->html->table(
						$this->private->templates["side"],
						"Products",
						$this->ProcessPrice($products)
					),					
					"title"	=> $this->tpl_module["settings"]["set_widget_latest_products"]
				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);
	}

	function SideMenuFeatured($product = false) {
		global $base;

		$product = $this->__bk_get_products(1,"rand()" , "and item_featured=1 ");
		$product = $this->ProcessProducts($product , 1);

	
		if (!is_array($product[0])) {
			return "";
		}
		
		return CTemplateStatic::Replace(
			$this->private->templates["side"]->blockreplace(
				"WidgetFeatured",
				$product[0]
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"],
				"title"	=> $this->tpl_module["settings"]["set_widget_featured"]
			)
		);
	}

	function SideMenuLastSold($product = false) {
		global $base;

		$products = $this->__bk_get_last_sold($this->tpl_module["settings"]["set_widget_last_sold_items"]);

		if (!is_array($products)) {
			return "";
		}
		

		return CTemplateStatic::Replace(
			$this->private->templates["side"]->blockreplace(
				($product ? "FooterWidget": "SideWidget" ),
				array(	
					"products"	=> $base->html->table(
						$this->private->templates["side"],
						"Products",
						$this->ProcessPrice($products)
					),					

					"title"	=> $this->tpl_module["settings"]["set_widget_last_sold"]
				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);
	}

	function SideMenuRelated($product = false) {
		global $base;

		if ($_GET["category"]) {
			$condition = "AND cat_url=\"{$_GET[category]}\" ";
		}

		$products = $this->__bk_get_products($this->tpl_module["settings"]["set_widget_related_products_items"],"rand()" , $condition);

		if (!is_array($products)) {
			return "";
		}
		

		return CTemplateStatic::Replace(
			$this->private->templates["side"]->blockreplace(
				($product ? "FooterWidget": "SideWidget" ),
				array(	
					"products"	=> $base->html->table(
						$this->private->templates["side"],
						"Products",
						$this->ProcessPrice($products)
					),					
					"title"	=> $this->tpl_module["settings"]["set_widget_related_products"]
				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);
	}

	function SideMenuBestSold($product = false) {
		global $base;

		if ($_GET["category"]) {
			$condition = "AND cat_url=\"{$_GET[category]}\" AND item_sales ";
		} else
			$condition = "AND item_sales ";

		$products = $this->__bk_get_products($this->tpl_module["settings"]["set_widget_best_sold_items"],"item_sales DESC" , $condition);

		if (!is_array($products)) {
			return "";
		}
		

		return CTemplateStatic::Replace(
			$this->private->templates["side"]->blockreplace(
				($product ? "FooterWidget": "SideWidget" ),
				array(	
					"products"	=> $base->html->table(
						$this->private->templates["side"],
						"Products",
						$this->ProcessPrice($products)
					),					

					"title"	=> $this->tpl_module["settings"]["set_widget_best_sold"]
				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);
	}

	function SideMenuLastVisited($product = false) {
		global $base , $_SESS;

		if (!count($_SESS["products"][$this->tpl_module["mod_id"]]["visited"])) {
			return "";
		}
		

		$products = $this->__bk_get_products($this->tpl_module["settings"]["set_widget_last_visited_items"],"" , " AND item_id IN (" . implode("," , $_SESS["products"][$this->tpl_module["mod_id"]]["visited"]) . ")");

		return CTemplateStatic::Replace(
			$this->private->templates["side"]->blockreplace(
				($product ? "FooterWidget": "SideWidget" ),
				array(	
					"products"	=> $base->html->table(
						$this->private->templates["side"],
						"Products",
						$this->ProcessPrice($products)
					),					
					"title"	=> $this->tpl_module["settings"]["set_widget_last_visited"]
				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);
	}


	function Product() {
		global $_SESS , $_TSM;

		$category = $this->__bk_get_category($_GET["category"]);
		$product = $this->__bk_get_product($_GET["product_id"]);


		//process product image
		$product["image"] = $this->private->templates["product"]->BlockReplace(
			$product["item_image_large"] ? "Image" : "NoImage",
			$product
		);

		//process the price
		$product = $this->ProcessPrice($product,true);

		//save this product in visited
		$_SESS["products"][$this->tpl_module["mod_id"]]["visited"][$product["item_id"]] = $product["item_id"];

		//update the product hits
		$this->db->QUeryUpdate(
			$this->tables["plugin:shop_items"],
			array(
				"item_hits"		=> $product["item_hits"] + 1,
			),
			"item_id={$product[item_id]}"
		);

		$product["variations"]		= $this->ProcessVariations($product);
		$product["specifications"]	= $this->ProcessSpecifications($product);

		$product["brief"] = $this->private->templates["product"]->BlockReplace(
			"Brief" . ($product["variations"] ? "Vars" : "NoVars" ) ,
			$product
		);


		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				$category["cat_title"] => $this->tpl_module["mod_url"] . "/" . $category["cat_url"] . "/",
				$product["item_title"] => ""
			)
		);

		//process for add to cart button
		if ($this->tpl_module["mod_shopping"]) {
			$product["add_cart"] = $this->private->templates["product"]->blockReplace(
				$product["variations"] ? "AddCart" : "AddCartSimple",
				$product
			);
		} else {
			$product["add_cart"] = "";
		}
		

		return CTemplateStatic::replace(
			$this->private->templates["product"]->blockReplace(
				"Main",
				array(
					"sidebar"		=> $this->SideMenu($this->tpl_module["settings"]["set_product_side"]),
					"content"		=> $this->private->templates["product"]->BlockReplace(
						"Product",
						$product
					),

					"left_widget"	=> $this->Widget($this->tpl_module["settings"]["set_product_widget_1"]),
					"right_widget"	=> $this->Widget($this->tpl_module["settings"]["set_product_widget_2"]),

				)
			),
			array(
				"mod_url"	=> $this->tpl_module["mod_url"]
			)
		);

	}

	function ProcessVariations($product) {
		global $base;

		if (!$product["item_variations"]) {
			return "";
		}
		
		$vars = explode("\n" , $product["item_variations"]);
		
		if (is_array($vars)) {
			foreach ($vars as $key => $val) {
				$val = trim($val);

				if ($val) {
					$tmp = explode("|" , $val);
					$options = explode("," , trim($tmp[1]));

					if (count($options)) {
						$opt = array();

						foreach ($options as $_key => $_val) {
							$opt[] = array("code"	=> $_val);
						}
						
						$variations[] = array(
							"title"		=> $tmp[0],
							"options"	=> $opt
						);
					}
					
				}
				
			}

			
			if (is_array($variations)) {
				foreach ($variations as $key => $val) {
					$variations[$key]["items"] = CTemplateStatic::Replace(
						$base->html->Table(
							$this->private->templates["product"],
							"VariationsOptions",
							$val["options"]
						),
						$val
					);
				}
				

				return $base->html->Table(
					$this->private->templates["product"],
					"Variations",
					$variations
				);
			}
						
		}
		
	}

	function ProcessSpecifications($product) {
		global $base;

		if (!$product["item_specifications"]) {
			return "";
		}
		
		$vars = explode("\n" , $product["item_specifications"]);

		
		if (is_array($vars)) {
			foreach ($vars as $key => $val) {
				$val = trim($val);

				if ($val) {
					$tmp = explode("|" , $val);

					if (count($tmp)) {
						$opt = array();

						foreach ($tmp as $_key => $_val) {
							$opt[] = array("value"	=> $_val);
						}

						$specs[] = $opt;
					}									
				}				
			}

			if (is_array($specs)) {
				$found = false;
				foreach ($specs as $key => $val) {
					if (is_array($val)) {
						foreach ($val as $k => $v) {
							$specs[$key]["items"] .= $this->private->templates["product"]->blockreplace(
								"Specifications" . ($found ? "Td" : "Th") , 
								$v
							);
						}					
					}

					$found = true;
				}

				return $base->html->Table(
					$this->private->templates["product"],
					"Specifications",
					$specs
				);				
			}
			
		}
	}
	

	function ProcessPrice($products , $single = false) {

		if ($single) {
			$products["price"] =  $this->ProcessSinglePrice($products["item_price"]);

			return $products;
		}
		
		if (is_Array($products)) {
			foreach ($products as $key => $val) {
				$products[$key]["price"] = $this->ProcessSinglePrice($val["item_price"]) ;
			}			
		}

		return $products;
	}

	function ProcessSinglePrice($text) {

		switch ($this->vars->data["set_shop_currencyposition"]) {
			case "before":
				return $this->vars->data["set_shop_currency_sign"] . number_format($text , 2) ;
			break;

			case "after":
				return number_format($text , 2) . $this->vars->data["set_shop_currency_sign"]  ;
			break;
		}
		

		
	}

	
	function Widget($code) {
		switch ($code) {
			case "latest_products":
				return $this->SideMenuLatestProducts(true);
			break;

			case "best_sellers":
				return $this->SideMenuBestSold(true);
			break;

			case "last_sold":
				return $this->SideMenuLastSold(true);
			break;

			case "last_visited":
				return $this->SideMenuLastVisited(true);
			break;

			case "random_products":
				return $this->SideMenuRelated(true);
			break;
		}
	}

	function ProcessProducts($products , $cnt) {
		if (is_array($products)) {
			$count = 1;
			
			foreach ($products as $key => $val) {
	
				if ($count != ($cnt )) {
					$products[$key]["class"] = "";
					$products[$key]["extra"] = "";
				} else {
				
					$products[$key]["class"] = $this->private->templates["products"]->BlockReplace("class-last" , $val);
					$products[$key]["extra"] = $this->private->templates["products"]->BlockReplace("Extra" , $val);
				}

				$products[$key]["cnt"] = $count;

				if ($count < ($cnt)) {						
					$count ++;
				} else {
					$count = 1;
				}

				//process the add to cart
				if ($this->tpl_module["mod_shopping"]) {
					$products[$key]["add_cart"] = $this->private->templates["products"]->BlockReplace("AddCart" , $val);
				} else {
					$products[$key]["add_cart"] = "";
				}
				

			}

			return $this->ProcessPrice($products);
		}

	}
	
	function AddToCart() {
		global $_SESS , $_CONF;

		if (is_array($_SESS["cart"])) {

			$_SESS["cart"][] = array( 
				"pid"		=> $_GET["product"],
				"options"	=> $_POST,
				"qty"		=> 1,
			);
			
		} else {
			$_SESS["cart"] = array(
				1	=>	array( 
					"pid"		=> $_GET["product"],
					"options"	=> $_POST,
					"qty"		=> 1,
				)
			);
		}
		
		//load the shopping cart 
		$module = $this->module->plugins["modules"]->LoadDefaultModule("shop");
	
		if (!$this->vars->data["set_links_type"]) {
				$module["mod_url"] = "index.php/" . $module["settings"]["set_url"] . "/";				
		} else
			$module["mod_url"] = $module["settings"]["set_url"] . "/";

		header("Location: " . $_CONF["url"] . $module["mod_url"]);
		exit;
		
	}
		
	
	function __bk_get_products($count , $order , $condition = "") {
		$products = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:shop_cats']} as c,{$this->tables['plugin:shop_items']} " . "
			WHERE item_cat=cat_id AND c.module_id={$this->tpl_module['mod_id']} " . 
			$condition . 
			($order ? "ORDER BY {$order}" : "" ) . 
			" LIMIT $count "
		);

		return $products;
	}	

	function __bk_get_last_sold($count ) {
		$products = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:shop_cart']} as cart,{$this->tables['plugin:shop_cats']} as c,{$this->tables['plugin:shop_items']} " .
			"WHERE item_cat=cat_id AND c.module_id={$this->tpl_module['mod_id']} AND cart.item_product_sku = item_sku " . 
			"ORDER BY cart.item_id  DESC " . 
			"LIMIT $count "
			
		);

		return $products;
	}	

	function __bk_get_category_products($category , $count = 10, $page = 1 , $order = "item_date DESC") {

		$page = (int)$page ? $page : 1;

		//debug($conds);

		$fields = "*";
		
		$items = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:shop_cats']} as c,{$this->tables['plugin:shop_items']} " . "
			WHERE item_cat=cat_id AND cat_id={$category[cat_id]} AND c.module_id={$this->tpl_module['mod_id']} " . 

			"ORDER BY  {$order} " . 
			"LIMIT " . ( ($page - 1 ) * $count ) . " , " . $count 
		);
		

		//get the elements count
		$items_count = $this->db->RowCount(
			$this->tables['plugin:shop_items'],
			"WHERE item_cat={$category[cat_id]} AND module_id={$this->tpl_module['mod_id']} "
		);
		
		return array(
			"records"	=> $items , 
			"count"		=> $items_count , 
			"pages"		=> $items_count ? ceil($items_count / $count) : 1,
			"page"		=> $page,
			"search"	=> $conds["search"]
		);		
	}

	function __bk_get_all_products($count = 10, $page = 1 , $order = "item_date DESC") {

		$page = (int)$page ? $page : 1;

		//debug($conds);

		$fields = "*";
		
		$items = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:shop_cats']} as c,{$this->tables['plugin:shop_items']} " . "
			WHERE item_cat=cat_id AND c.module_id={$this->tpl_module['mod_id']} " . 

			"ORDER BY  {$order} " . 
			"LIMIT " . ( ($page - 1 ) * $count ) . " , " . $count 
		);
		

		//get the elements count
		$items_count = $this->db->RowCount(
			"{$this->tables['plugin:shop_cats']} as c,{$this->tables['plugin:shop_items']}",
			"WHERE item_cat=cat_id AND c.module_id={$this->tpl_module['mod_id']} "
		);
		
		return array(
			"records"	=> $items , 
			"count"		=> $items_count , 
			"pages"		=> $items_count ? ceil($items_count / $count) : 1,
			"page"		=> $page,
			"search"	=> $conds["search"]
		);		
	}

	
	
	function __bk_get_categories() {
		$categories = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:shop_cats']} WHERE module_id={$this->tpl_module['mod_id']} ORDER BY cat_order ASC"
		);

		return $categories;
	}
	
	function __bk_get_category($url) {
		$category = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['plugin:shop_cats']} WHERE module_id={$this->tpl_module['mod_id']} AND cat_url='{$url}'"
		);

		return $category;
	}

	function __bk_get_product($id) {
		$product = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['plugin:shop_items']} WHERE module_id={$this->tpl_module['mod_id']} AND item_id='{$id}'"
		);

		return $product;
	}

	function __bk_get_product_by_id($id) {
		$product = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['plugin:shop_items']} WHERE item_id='{$id}'"
		);

		return $product;
	}

	function __bk_search_products($q , $count , $page) {

		$page = (int)$page ? $page : 1;

		if ($q) {
			$q = explode(" " , $q);

			foreach ($q as $key => $val) {
				//search only in tag
				$q_sql[] = " (item_title LIKE '%{$val}%' OR item_description LIKE '%{$val}%') ";
			}

			$conds = " AND (" .  implode(" AND " , $q_sql) . ") ";
		}
				

		//debug($conds);

		$fields = "*";
		
		$products = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:shop_cats']} as c,{$this->tables['plugin:shop_items']} " . "
			WHERE item_cat=cat_id  AND c.module_id={$this->tpl_module['mod_id']} " . 
			$conds .

			"ORDER BY  item_title ASC " . 
			"LIMIT " . ( ($page - 1 ) * $count ) . " , " . $count 
		);

		//get the elements count
		$products_count = $this->db->RowCount(
			"{$this->tables['plugin:shop_cats']} as c,{$this->tables['plugin:shop_items']} " ,
			"WHERE item_cat=cat_id  AND c.module_id={$this->tpl_module['mod_id']} " . 
			$conds
		);
		
		return array(
			"records"	=> $products , 
			"count"		=> $products_count , 
			"pages"		=> $products_count ? ceil($products_count / $count) : 1,
			"page"		=> $page,
		);		

	}

	function GetAllLinks($module , $links) {
		$cats = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:shop_cats']} WHERE module_id={$module[mod_id]} ORDER BY cat_order ASC");

		if (is_array($cats)) {

			foreach ($cats as $key => $val) {
				$links[] = array(
					"url" => $module["mod_url"] . "/" . $val["cat_url"] . "/",
					"priority"	=> "0.6",
				);
			}			
		}


		$products = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:shop_cats']} as c,{$this->tables['plugin:shop_items']} " . "
			WHERE item_cat=cat_id  AND c.module_id={$module['mod_id']} " 
		);

		if (is_array($products)) {

			foreach ($products as $key => $val) {
				$links[] = array(
					"url" => $module["mod_url"] . "/" . $val["cat_url"] . "/" . $val["item_url"] . "-" . $val["item_id"] . "/",
					"priority"	=> "0.6",
				);
			}			
		}

	}
	
	
}

?>